]> rtime.felk.cvut.cz Git - can-benchmark.git/blob - gw-tests/lib.sh
genhtml: Display navigation in tables
[can-benchmark.git] / gw-tests / lib.sh
1 set -e
2
3 COUNT=10000
4
5 OPT_TRAFFIC=oneatatime
6
7 error() {
8     echo $1 >&2
9     exit 1
10 }
11
12 while [ $# -gt 0 ]; do
13     case "$1" in
14         -P|--no-plot) OPT_PLOT_DISABLE=1; shift;;
15         -p|--plot) OPT_PLOT_ONLY=1; shift;;
16         -X|--no-x11-plot) OPT_NO_X11=1; shift;;
17         -t) case "$2" in
18                 all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
19                 *) error "Unknown traffic specification: $2";;
20             esac;
21             shift 2;;
22     esac
23 done
24
25 PATH=$PWD/../_compiled/bin/:$PATH
26
27 sshgw() {
28     local socket="$HOME/.ssh/cangw-connection"
29
30     if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
31         # Create master connection to speed up subsequenct command.
32         # The ssh is put into background and the connection is closed
33         # after 10 minutes)
34         ssh -f -M -S $socket root@192.168.2.3 sleep 600 > /dev/null 2>&1
35     fi
36     ssh -x -a -S $socket root@192.168.2.3 "$@"
37 }
38
39 cleanupgw() {
40     sshgw 'cangw -F'
41 }
42
43 _plot() {
44     local testname=`basename $0 .sh`
45
46     plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n(GW kernel $kvers, traffic $traffic)\"/" > plot.gp
47     if [[ ! -s plot.gp ]]; then return; fi
48     if [ -z "$OPT_NO_X11" ]; then
49         echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
50     fi
51     I=''
52     echo 'set terminal postscript color eps enhanced size 6cm,4cm lw 1 "Times-Roman" 10;' \
53         'set lmargin 8;' \
54         "$(< plot.gp)" | gnuplot > ${testname}$I.eps
55     echo "set terminal postscript color eps enhanced;" \
56         "$(< plot.gp)" | gnuplot | epstopdf --filter > ${testname}$I.pdf
57     mkdir -p thumb
58     convert -density 30  -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.pdf thumb/${testname}$I.png
59     convert -density 150 -gamma 0.7 -quality 90 -type Palette -depth 8 ${testname}$I.pdf ${testname}$I.png
60
61 }
62
63 echo_plot() {
64     plot=$1
65     [[ "$_plot_separator" ]] && echo ", \\"
66     _plot_separator=t
67     echo -n "    " $plot
68 }
69
70 traffic_and_length() {
71     local opts
72     case $traffic in
73         flood) opts='';;
74         50)        opts="-p $((2*(44+$1*8)))";;
75         oneatatime)        opts="-o";;
76         *) error "Unknown traffic specification"
77     esac
78     echo $opts -l $1
79 }
80
81 start_load() {
82 }
83
84 kill_load() {
85 }
86
87 _measure() {
88     # Remove data from the last measurement
89     rm -rf *
90     touch .results
91     cat > plot.sh <<-EOF
92         #!/bin/bash
93         export kvers=$kvers
94         export hostkvers=$hostkvers
95         export traffic=$traffic
96         cd \$(dirname \$0)/$(dirname $script)
97         exec ./$(basename $script) --plot "\$@"
98         EOF
99     chmod +x plot.sh
100     # Set can interfaces up
101     sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
102     # Delete all vcan interfaces
103     sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
104     # Reset priorities
105     sshgw 'if pid=`pidof irq/145-can0`; then chrt -p -f 50 $pid > /dev/null; fi'
106     sshgw 'if pid=`pidof irq/146-can1`; then chrt -p -f 50 $pid > /dev/null; fi'
107     sshgw 'if pid=`pidof sirq-net-rx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
108     sshgw 'if pid=`pidof sirq-net-tx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
109     # Set the length of qdisc queue to avoid ENOBUFS errors
110     ifconfig can0 txqueuelen 200
111     cleanupgw
112
113     prepare
114     start_load
115     main
116     kill_load
117 }
118
119
120 _run() {
121     if [[ $OPT_TRAFFIC = all ]]
122     then traffics="flood 50 oneatatime"
123     else traffics=${traffic:-$OPT_TRAFFIC}
124     fi
125     hostkvers=${hostkvers:-host-$(uname -r)}
126     kvers=${kvers:-$(sshgw uname -r)}
127     test=$(basename $0 .sh)
128     for traffic in $traffics; do
129         dir="results/$hostkvers/$kvers/$traffic/$test"
130         mkdir -p $dir
131         script=$(echo $dir | sed -e 's/[^/]*/../g')/${test}.sh
132         cd $dir
133         if [[ ! "$OPT_PLOT_ONLY" ]]; then
134             echo "Working directory: $dir"
135             _measure
136         fi
137         if [[ ! "$OPT_PLOT_DISABLE" ]]; then
138             _plot
139         fi
140         cd - > /dev/null
141     done
142 }
143
144 test_end() {
145     test_end_called=t
146     exit_ok=
147     _run
148     exit_ok=t
149 }
150
151 _myexit() {
152     code=$?
153     cmd=$BASH_COMMAND
154     if [[ ! "$test_end_called" ]]; then
155         test_end_called=t
156         error "bug in the test script: No test_end called"
157     fi
158     if ! test -n "$exit_ok"; then
159         error "FATAL: Command '$cmd' exit with code $code"
160     fi
161 }
162
163 trap '_myexit' EXIT